/**
 *
 *
  _____                      _              _ _ _     _   _     _        __ _ _
 |  __ \                    | |            | (_) |   | | | |   (_)      / _(_) |
 | |  | | ___    _ __   ___ | |_    ___  __| |_| |_  | |_| |__  _ ___  | |_ _| | ___
 | |  | |/ _ \  | '_ \ / _ \| __|  / _ \/ _` | | __| | __| '_ \| / __| |  _| | |/ _ \
 | |__| | (_) | | | | | (_) | |_  |  __/ (_| | | |_  | |_| | | | \__ \ | | | | |  __/
 |_____/ \___/  |_| |_|\___/ \__|  \___|\__,_|_|\__|  \__|_| |_|_|___/ |_| |_|_|\___|

 * DO NOT EDIT THIS FILE!!
 *
 *  FOR CUSTOMIZE suscripcionBaseService PLEASE EDIT ../suscripcion.service.ts
 *
 *  -- THIS FILE WILL BE OVERWRITTEN ON THE NEXT SKAFFOLDER'S CODE GENERATION --
 *
 */
// DEPENDENCIES
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { HttpClient } from '@angular/common/http';

// CONFIG
import { environment } from '../../../environments/environment';

// MODEL
import { Suscripcion } from '../../domain/gifloadmin_db/suscripcion';

/**
 * THIS SERVICE MAKE HTTP REQUEST TO SERVER, FOR CUSTOMIZE IT EDIT ../Suscripcion.service.ts
 */

/*
 * SCHEMA DB Suscripcion
 *
    {
        codigo_pago: {
            type: 'String'
        },
        cupon: {
            type: 'String'
        },
        descuento: {
            type: 'Number'
        },
        documento: {
            type: 'String'
        },
        estado: {
            type: 'String'
        },
        fecha_pago: {
            type: 'Date'
        },
        fecha_registro: {
            type: 'Date'
        },
        iva: {
            type: 'Number'
        },
        plan: {
            type: 'String'
        },
        subtotal: {
            type: 'Number'
        },
        total: {
            type: 'Number'
        },
        usuario: {
            type: 'String'
        },
        vigencia_fin: {
            type: 'Date'
        },
        vigencia_inicio: {
            type: 'Date'
        },
        //RELATIONS
        //EXTERNAL RELATIONS
        suscripciones: {
            type: Schema.ObjectId,
            ref : "User"
        },
    }
 *
 */
@Injectable()
export class SuscripcionBaseService {

    contextUrl: string = environment.endpoint + '/system/';
    constructor(
        protected http: HttpClient
    ) { }

    // CRUD METHODS

    /**
    * SuscripcionService.get
    *   @description CRUD ACTION get
    *   @param ObjectId id Id Suscripcion
    *   @returns Suscripcion
    *
    */
    get(id: string): Observable<Suscripcion> {
        return this.http
            .get<Suscripcion>(this.contextUrl + 'suscripcion/' + id)
            .pipe(map(data => data));
    }

    /**
    * SuscripcionService.list
    *   @description CRUD ACTION list
    *   @returns ARRAY OF Suscripcion
    *
    */
    list(filter = '', codigoPago: string, sortOrder = 'asc', pageNumber: number, pageSize: number): Observable<any> {
        filter = filter.trim().length == 0 ? '-1' : filter;
        codigoPago = codigoPago.trim().length == 0 ? '-1' : codigoPago;
        return this.http
            .get<any>(this.contextUrl + 'suscripcion/search/findByVariedadAndEmpresa', { params: { 'filter': filter, 'codigoPago': codigoPago, 'page': pageNumber, 'size': pageSize, 'sortOrder': sortOrder } })
            .pipe(map(data => data['_embedded']['suscripcions']));
    }

    /**
    * SuscripcionService.update
    *   @description CRUD ACTION update
    *   @param ObjectId id Id Suscripcion
    *   @returns Suscripcion
    *
    */
    update(item: Suscripcion): Observable<Suscripcion> {
        return this.http
            .post<Suscripcion>(this.contextUrl + 'rest/suscripcion/state', item)
            .pipe(map(data => data));
    }


}
